//
//  Canvas.h
//  DodgeBurn
//
//  Created by Andy Finnell on 9/6/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class GenericBrush;

@interface Canvas : NSObject {
	// Because we want to be able to both draw into the canvas as well as use 
	//	it as a brush, back the canvas as a CGLayerRef. Also, CGLayeRef's
	//	give better performance when stamping.
	CGLayerRef			mLayer;	
}

// Resize the canvas to the size of the image and render the image onto the canvas
- (void) setImage:(NSImage *)image view:(NSView *)view;

	// Draws the contents of the canvas into the specified context. Handy for views
	//	that host a canvas.
- (void)drawRect:(NSRect)rect inContext:(NSGraphicsContext*)context;

	// Graphics privimites for the canvas. The first draws a line given the brush
	//	and the second draws a point given the brush.
- (float)stamp:(GenericBrush *)brush from:(NSPoint)startPoint to:(NSPoint)endPoint leftOverDistance:(float)leftOverDistance;
- (void)stamp:(GenericBrush *)brush at:(NSPoint)point;

// Grab the context used to draw onto the context. 
- (CGContextRef) context;

// Grab the corresponding Core Image image.
- (CIImage *) image;

@end
