//
//  FilterBrush.h
//  Sponge
//
//  Created by Andy Finnell on 9/12/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import "GenericBrush.h"

// A brush for applying filters
@interface FilterBrush : GenericBrush {
	// We cache these values because they're expensive to create and destroy
	CIFilter	*mFilter;		// The filter to apply (duh)
	CIContext	*mCIContext;	// The context to apply the filter to
}

// Helper function to ensure our filter is loaded
- (void) loadFilter:(NSString *)filterName fromPlugin:(NSString *)pluginName;

// Has to be implemented by subclasses
- (CIFilter *) filter; // Override for subclasses to implement

@end
