//
//  Sponge.m
//  Sponge
//
//  Created by Andy Finnell on 9/6/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "Sponge.h"

#import <QuartzCore/QuartzCore.h>

@implementation Sponge

- (id) init 
{
	self = [super init];
	if ( self != nil ) {		
		// Set the default values for our parameters
		mFlow = 0.5;
		mMode = kSpongeMode_Desaturate;
	}
	return self;
}

- (CIFilter *) filter
{
	// We need to create and configure our filter here.	CIColorControls has controls
	//	for saturation which is what we care about.
	CIFilter * filter = [CIFilter filterWithName:@"CIColorControls"];
	[filter setDefaults];
	if ( mMode == kSpongeMode_Saturate )
		[filter setValue:[NSNumber numberWithFloat:1 + mFlow] forKey:@"inputSaturation"];
	else
		[filter setValue:[NSNumber numberWithFloat:1 - mFlow] forKey:@"inputSaturation"];
		
	return filter;
}

- (float) spacing
{
	// By default, most brushes probably want a 1/4 spacing
	return CGImageGetWidth(mMask) * 0.25;
}

@end
